<script lang="ts" setup>
import type { BasePage } from '@/types/base';
import { pathToID } from '@/utils/pathToID';

const { path } = useRoute();
const page: BasePage = await useGitlabContent();
// Generic SEO configuration
useGitlabSeo(page.seo);

// Use a specific layout, use the "default" one if undefined
setPageLayout(page.config?.layout);

// Error handler for better debugging
useErrorHandler();

// Enable AOS for the current page
if (page.config?.enableAnimations) {
  useAOS();
} else {
  if (import.meta.client) {
    document.body.classList.add('aos-disabled');
  }
}

if (!page.content) {
  throw createError({
    statusCode: 500,
    message: `Page is missing the "content" attribute: ${path}`,
  });
}

const resolvedTemplate = await import(`@/components/templates/${page.config?.template || 'Common'}.vue`);
</script>

<template>
  <div :id="pathToID(path)">
    <component :is="resolvedTemplate.default" :content="page.content" />
  </div>
</template>
